; 
    include \masm32\include\masm32rt.inc

    ;-----------------------------------------------------------
    ; SI decimal prefix values, as floating-point initializers:
    ;-----------------------------------------------------------

    KILO equ 1000.0
    MEGA equ 1000000.0
    GIGA equ 1000000000.0
    TERA equ 1000000000000.0
    PETA equ 1000000000000000.0

    ;-----------------------------------------------------------
    ; IEC binary prefix values, as floating-point initializers:
    ;-----------------------------------------------------------

    KIBI equ 1024.0
    MEBI equ 1048576.0
    GIGI equ 1073741824.0
    TEBI equ 1099511627776.0
    PEBI equ 1125899906842624.0

    ;----------------------------------------------------------------
    ; This macro scales the value in EDX:EAX by the specified prefix
    ; value and returns the result as a REAL8 in EDX:EAX.
    ;----------------------------------------------------------------

    SCALE MACRO prefix_value
      push edx
      push eax
      fild QWORD PTR [esp]
      fld8 prefix_value
      fdiv
      fstp QWORD PTR [esp]
      pop eax
      pop edx
    ENDM

; 
    .data
    .code
; 
start:
; 

    FOR scale_value,<KILO,MEGA,GIGA,TERA,PETA,KIBI,MEBI,GIGI,TEBI,PEBI>
      mov eax, 1
      mov edx, 0
      SCALE scale_value
      invoke crt_printf, chr$("&scale_value %.14f%c"), edx::eax, 10
    ENDM
    print chr$(13,10)

    FOR scale_value,<KILO,MEGA,GIGA,TERA,PETA,KIBI,MEBI,GIGI,TEBI,PEBI>
      mov eax, 0
      mov edx, 1
      SCALE scale_value
      invoke crt_printf, chr$("&scale_value %.14f%c"), edx::eax, 10
    ENDM
    print chr$(13,10)

    FOR scale_value,<KILO,MEGA,GIGA,TERA,PETA,KIBI,MEBI,GIGI,TEBI,PEBI>
      mov eax, 0
      mov edx, 7fffffffh
      SCALE scale_value
      invoke crt_printf, chr$("&scale_value %.14f%c"), edx::eax, 10
    ENDM
    print chr$(13,10)

    FOR scale_value,<KILO,MEGA,GIGA,TERA,PETA,KIBI,MEBI,GIGI,TEBI,PEBI>
      mov eax, 0ffffffffh
      mov edx, 7fffffffh
      SCALE scale_value
      invoke crt_printf, chr$("&scale_value %.14f%c"), edx::eax, 10
    ENDM
    print chr$(13,10)

    inkey "Press any key to exit..."
    exit
; 
end start
 